#   import statements

import G2_LogicalTag
from Tkinter import *

class G2_LogicalTag_controlPanel:
	'''This class defines a control / display panel that tests the various methods of the 
	G2_LogicalTag class.'''
	
	def __init__(self,parent):
		
		self.currQRN=0x0000	#  random number returned when a tag's slot counter is 0 on a Query/Rep/Adj
		self.currHandle=0x0000	#  random number used to identify a tag during an access session
		self.currCover=0x0000
		self.Tari=25		#  initial value of Tari
		self.RTcal=75		#  initial value of RTcal
		self.TRcal=150		#  initial value of TRcal
		self.CommandTime=[0,0]  #  CommandTime[0]=start time for a command; CommandTime[1]=stop time for that command
		
		#  instantiate a tag
		
		self.testTag=G2_LogicalTag.G2_LogicalTag()
		self.tagWorldTime=0			# time in microseconds in the virtual world
		
		#   now set up the display frames and widgets
		
		self.myparent=parent		#  the parent frame or window for the control panel
		self.mycontainer1=Frame(parent,bg='#aca')	#  this is the frame that contains the whole control panel and all widgets
		self.mycontainer1.pack()
		
		#  now split up the main frame into subframes to contain the various control / display elements
		
		self.topframe=Frame(self.mycontainer1,bg='#fff',relief=SUNKEN, borderwidth=5)    
		self.topframe.pack(side=TOP)
		#  top frame used to contain the tag display, which was moved (4/15/08) to its own window
		
		self.bottomframe=Frame(self.mycontainer1,bg='#bbb', relief=SUNKEN, borderwidth=5)  
		self.bottomframe.pack(side=BOTTOM)
				
		self.midframe=Frame(self.bottomframe)      
		self.midframe.pack(side=TOP)
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Tag State Display Frame in new window
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		self.newWindow=Toplevel(self.myparent)
                
		self.tagStateFrame=Frame(self.newWindow,bg='#fff')	#  this frame contains the tag state display
		self.tagStateFrame.pack(side=LEFT, fill=Y)
		
		self.leftStateFrame=Frame(self.tagStateFrame,bg='#fff')
		self.leftStateFrame.pack(side=LEFT,fill=Y)
		
		self.midStateFrame=Frame(self.tagStateFrame,bg='#fff')
		self.midStateFrame.pack(side=LEFT,fill=Y)
		
		self.rightStateFrame=Frame(self.tagStateFrame,bg='#fff')
		self.rightStateFrame.pack(side=LEFT,fill=Y)
		
		self.farRightStateFrame=Frame(self.tagStateFrame,bg='#fff')   # not a political statement!
		self.farRightStateFrame.pack(side=RIGHT,fill=Y)
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Flag display frames
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
		self.flagFrame=Frame(self.leftStateFrame,bg='#fff')
		self.flagFrame.pack(side=TOP,fill=X)
		
		self.flagLabelFrame=Frame(self.flagFrame,bg='#fff')
		self.flagLabelFrame.pack(side=LEFT,fill=Y)
		
		self.flagStateFrame=Frame(self.flagFrame,bg='#fff')
		self.flagStateFrame.pack(side=LEFT,fill=Y)
		
		self.currSessionFrame=Frame(self.leftStateFrame,bg='#fff')
		self.currSessionFrame.pack(side=TOP,fill=X)	

		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Flag states / session
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!			
		
		self.SLlabel=Label(self.flagLabelFrame,text='SL')
		self.SLlabel.pack(side=TOP,fill=X)
		
		self.S0label=Label(self.flagLabelFrame,text='S0')
		self.S0label.pack(side=TOP,fill=X)	
		
		self.S1label=Label(self.flagLabelFrame,text='S1')
		self.S1label.pack(side=TOP,fill=X)		
		
		self.S2label=Label(self.flagLabelFrame,text='S2')
		self.S2label.pack(side=TOP,fill=X)
		
		self.S3label=Label(self.flagLabelFrame,text='S3')
		self.S3label.pack(side=TOP,fill=X)
		
		self.SLstatus=Text(self.flagStateFrame,height=1,width=5,relief=SUNKEN,borderwidth=2)
		self.SLstatus.pack(side=TOP,fill=X)

		self.S0status=Text(self.flagStateFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.S0status.pack(side=TOP,fill=X)
		
		self.S1status=Text(self.flagStateFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.S1status.pack(side=TOP,fill=X)
		
		self.S2status=Text(self.flagStateFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.S2status.pack(side=TOP,fill=X)
		
		self.S3status=Text(self.flagStateFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.S3status.pack(side=TOP,fill=X)		
		
		
		self.currentSessionLabel=Label(self.currSessionFrame,text='current session',borderwidth=1)
		self.currentSessionLabel.pack(side=LEFT)
		
		self.currentSession=Text(self.currSessionFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.currentSession.pack(side=RIGHT)
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	handle / counter
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.QRNFrame=Frame(self.leftStateFrame,bg='#fff')
		self.QRNFrame.pack(side=TOP,fill=X)		
	
		self.QRNLabel=Label(self.QRNFrame,text='QRN')
		self.QRNLabel.pack(side=LEFT)
		
		self.QRNValue=Text(self.QRNFrame,height=1,width=8,relief=SUNKEN,borderwidth=2)
		self.QRNValue.pack(side=RIGHT)
		
		self.handleFrame=Frame(self.leftStateFrame,bg='#fff')
		self.handleFrame.pack(side=TOP,fill=X)
			
		self.handleLabel=Label(self.handleFrame,text='handle')
		self.handleLabel.pack(side=LEFT)
		
		self.handleValue=Text(self.handleFrame,height=1,width=8,relief=SUNKEN,borderwidth=2)
		self.handleValue.pack(side=RIGHT)
		
		self.counterFrame=Frame(self.leftStateFrame,bg='#fff')
		self.counterFrame.pack(side=TOP,fill=X)
		
		self.counterLabel=Label(self.counterFrame,text='slot counter')
		self.counterLabel.pack(side=LEFT)
		
		self.counterValue=Text(self.counterFrame,height=1,width=8,relief=SUNKEN,borderwidth=2)
		self.counterValue.pack(side=RIGHT)

		self.stateFrame=Frame(self.leftStateFrame,bg='#fff')
		self.stateFrame.pack(side=TOP,fill=X)
		
		self.stateLabel=Label(self.stateFrame,text='state')
		self.stateLabel.pack(side=LEFT)
		
		self.stateValue=Text(self.stateFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.stateValue.pack(side=RIGHT)
		
		self.QFrame=Frame(self.leftStateFrame,bg='#fff')
		self.QFrame.pack(side=TOP,fill=X)
		
		self.QLabel=Label(self.QFrame,text='tag Q')
		self.QLabel.pack(side=LEFT)
		
		self.QValue=Text(self.QFrame,height=1,width=4,relief=SUNKEN,borderwidth=2)
		self.QValue.pack(side=RIGHT)
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Memory banks
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.amidStateFrame=Frame(self.midStateFrame,bg='#fff')
		self.amidStateFrame.pack(side=LEFT,fill=Y)
		
		self.bmidStateFrame=Frame(self.midStateFrame,bg='#fff')
		self.bmidStateFrame.pack(side=RIGHT,fill=Y)
		
		
		self.Bank0Frame=Frame(self.amidStateFrame,bg='#fff')
		self.Bank0Frame.pack(side=TOP,fill=X)
		
		self.Bank1Frame=Frame(self.amidStateFrame,bg='#fff')
		self.Bank1Frame.pack(side=TOP,fill=X)
		
		self.Bank2Frame=Frame(self.bmidStateFrame,bg='#fff')
		self.Bank2Frame.pack(side=TOP,fill=X)
		
		self.Bank3Frame=Frame(self.bmidStateFrame,bg='#fff')
		self.Bank3Frame.pack(side=TOP,fill=X)
		
		self.Bank0Label=Label(self.Bank0Frame,text='Passwords')
		self.Bank0Label.pack(side=TOP)
		
		self.Bank1Label=Label(self.Bank1Frame,text='EPC')
		self.Bank1Label.pack(side=TOP)
		
		self.Bank2Label=Label(self.Bank2Frame,text='Tag ID')
		self.Bank2Label.pack(side=TOP)
		
		self.Bank3Label=Label(self.Bank3Frame,text='User')
		self.Bank3Label.pack(side=TOP)
		
		self.Bank0Value=Text(self.Bank0Frame,height=8,width=10,relief=SUNKEN,borderwidth=2)
		self.Bank0Value.pack(side=TOP)	
		
		self.Bank1Value=Text(self.Bank1Frame,height=8,width=10,relief=SUNKEN,borderwidth=2)
		self.Bank1Value.pack(side=TOP)	
		
		self.Bank2Value=Text(self.Bank2Frame,height=8,width=10,relief=SUNKEN,borderwidth=2)
		self.Bank2Value.pack(side=TOP)
		
		self.Bank3Value=Text(self.Bank3Frame,height=8,width=10,relief=SUNKEN,borderwidth=2)
		self.Bank3Value.pack(side=TOP)		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	PHY parameters
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.RTcalFrame=Frame(self.rightStateFrame,bg='#fff')
		self.RTcalFrame.pack(side=TOP,fill=X)
		
		self.RTcalLabel=Label(self.RTcalFrame,text='RTcal')
		self.RTcalLabel.pack(side=LEFT)
		
		self.RTcalValue=Text(self.RTcalFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.RTcalValue.pack(side=RIGHT)	
		
		self.TRcalFrame=Frame(self.rightStateFrame,bg='#fff')
		self.TRcalFrame.pack(side=TOP,fill=X)
		
		self.TRcalLabel=Label(self.TRcalFrame,text='TRcal')
		self.TRcalLabel.pack(side=LEFT)
		
		self.TRcalValue=Text(self.TRcalFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TRcalValue.pack(side=RIGHT)	
		
		self.DRFrame=Frame(self.rightStateFrame,bg='#fff')
		self.DRFrame.pack(side=TOP,fill=X)
		
		self.DRLabel=Label(self.DRFrame,text='divide ratio')
		self.DRLabel.pack(side=LEFT)
		
		self.DRValue=Text(self.DRFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.DRValue.pack(side=RIGHT)
		
		self.MFrame=Frame(self.rightStateFrame,bg='#fff')
		self.MFrame.pack(side=TOP,fill=X)
		
		self.MLabel=Label(self.MFrame,text='Miller index')
		self.MLabel.pack(side=LEFT)
		
		self.MValue=Text(self.MFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.MValue.pack(side=RIGHT)		
		
		self.TariFrame=Frame(self.rightStateFrame,bg='#fff')
		self.TariFrame.pack(side=TOP,fill=X)
		
		self.TariLabel=Label(self.TariFrame,text='Tari (rdr 0)')
		self.TariLabel.pack(side=LEFT)
		
		self.TariValue=Text(self.TariFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TariValue.pack(side=RIGHT)		
		
		self.TRextFrame=Frame(self.rightStateFrame,bg='#fff')
		self.TRextFrame.pack(side=TOP,fill=X)
		
		self.TRextLabel=Label(self.TRextFrame,text='pilot tone')
		self.TRextLabel.pack(side=LEFT)
		
		self.TRextValue=Text(self.TRextFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TRextValue.pack(side=RIGHT)		
		
		self.LFFrame=Frame(self.rightStateFrame,bg='#fff')
		self.LFFrame.pack(side=TOP,fill=X)
		
		self.LFLabel=Label(self.LFFrame,text='link freq. (KHz)')
		self.LFLabel.pack(side=LEFT)
		
		self.LFValue=Text(self.LFFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.LFValue.pack(side=RIGHT)
							
		self.TpriFrame=Frame(self.rightStateFrame,bg='#fff')
		self.TpriFrame.pack(side=TOP,fill=X)
		
		self.TpriLabel=Label(self.TpriFrame,text='Tpri (microsec)')
		self.TpriLabel.pack(side=LEFT)
		
		self.TpriValue=Text(self.TpriFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TpriValue.pack(side=RIGHT)		
							
		self.T1Frame=Frame(self.rightStateFrame,bg='#fff')
		self.T1Frame.pack(side=TOP,fill=X)
		
		self.T1Label=Label(self.T1Frame,text='T1 (microsec)')
		self.T1Label.pack(side=LEFT)
		
		self.T1Value=Text(self.T1Frame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.T1Value.pack(side=RIGHT)	
			
		self.T2maxFrame=Frame(self.rightStateFrame,bg='#fff')
		self.T2maxFrame.pack(side=TOP,fill=X)
		
		self.T2maxLabel=Label(self.T2maxFrame,text='T2 max (microsec)')
		self.T2maxLabel.pack(side=LEFT)
		
		self.T2maxValue=Text(self.T2maxFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.T2maxValue.pack(side=RIGHT)	
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Lock bits
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.KillLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.KillLockFrame.pack(side=TOP,fill=X)
		
		self.KillLockLabel=Label(self.KillLockFrame,text='KILL pwd')
		self.KillLockLabel.pack(side=LEFT)
		
		self.KillLockValueDisplay=Text(self.KillLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.KillLockValueDisplay.pack(side=RIGHT)

		self.KillPermaLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.KillPermaLockFrame.pack(side=TOP,fill=X)		
		
		self.KillPermaLockLabel=Label(self.KillPermaLockFrame,text='permalock')
		self.KillPermaLockLabel.pack(side=LEFT)
		
		self.KillPermaLockValueDisplay=Text(self.KillPermaLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.KillPermaLockValueDisplay.pack(side=RIGHT)		
		
		self.AccessLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.AccessLockFrame.pack(side=TOP,fill=X)		
		
		self.AccessLockLabel=Label(self.AccessLockFrame,text='ACCESS pwd')
		self.AccessLockLabel.pack(side=LEFT)
		
		self.AccessLockValueDisplay=Text(self.AccessLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.AccessLockValueDisplay.pack(side=RIGHT)	

		self.AccessPermaLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.AccessPermaLockFrame.pack(side=TOP,fill=X)		
		
		self.AccessPermaLockLabel=Label(self.AccessPermaLockFrame,text='permalock')
		self.AccessPermaLockLabel.pack(side=LEFT)
		
		self.AccessPermaLockValueDisplay=Text(self.AccessPermaLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.AccessPermaLockValueDisplay.pack(side=RIGHT)
				
		self.EPCLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.EPCLockFrame.pack(side=TOP,fill=X)		
		
		self.EPCLockLabel=Label(self.EPCLockFrame,text='EPC bank')
		self.EPCLockLabel.pack(side=LEFT)
		
		self.EPCLockValueDisplay=Text(self.EPCLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.EPCLockValueDisplay.pack(side=RIGHT)	

		self.EPCPermaLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.EPCPermaLockFrame.pack(side=TOP,fill=X)		
		
		self.EPCPermaLockLabel=Label(self.EPCPermaLockFrame,text='permalock')
		self.EPCPermaLockLabel.pack(side=LEFT)
		
		self.EPCPermaLockValueDisplay=Text(self.EPCPermaLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.EPCPermaLockValueDisplay.pack(side=RIGHT)	
		
		
		self.TIDLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.TIDLockFrame.pack(side=TOP,fill=X)		
		
		self.TIDLockLabel=Label(self.TIDLockFrame,text='TID bank')
		self.TIDLockLabel.pack(side=LEFT)
		
		self.TIDLockValueDisplay=Text(self.TIDLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TIDLockValueDisplay.pack(side=RIGHT)	

		self.TIDPermaLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.TIDPermaLockFrame.pack(side=TOP,fill=X)		
		
		self.TIDPermaLockLabel=Label(self.TIDPermaLockFrame,text='permalock')
		self.TIDPermaLockLabel.pack(side=LEFT)
		
		self.TIDPermaLockValueDisplay=Text(self.TIDPermaLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.TIDPermaLockValueDisplay.pack(side=RIGHT)	
		
		
		self.userLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.userLockFrame.pack(side=TOP,fill=X)		
		
		self.userLockLabel=Label(self.userLockFrame,text='user bank')
		self.userLockLabel.pack(side=LEFT)
		
		self.userLockValueDisplay=Text(self.userLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.userLockValueDisplay.pack(side=RIGHT)	

		self.userPermaLockFrame=Frame(self.farRightStateFrame,bg='#fff')
		self.userPermaLockFrame.pack(side=TOP,fill=X)		
		
		self.userPermaLockLabel=Label(self.userPermaLockFrame,text='permalock')
		self.userPermaLockLabel.pack(side=LEFT)
		
		self.userPermaLockValueDisplay=Text(self.userPermaLockFrame,height=1,width=10,relief=SUNKEN,borderwidth=2)
		self.userPermaLockValueDisplay.pack(side=RIGHT)						
		
		self.swLabel=Label(self.farRightStateFrame,text='oneTagWorld 2.0')
		self.swLabel.pack(side=TOP)
		
		self.swLabel2=Label(self.farRightStateFrame,text='Enigmatics')
		self.swLabel2.pack(side=TOP)
			
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Basic controls
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.controlFrame1=Frame(self.midframe,bg='#fff')
		self.controlFrame1.pack(side=LEFT,fill=Y,padx=2)
		
		self.controlFrame2=Frame(self.midframe,bg='#fff')
		self.controlFrame2.pack(side=LEFT,fill=Y)
		
		self.controlFrame3=Frame(self.midframe,bg='#fff')
		self.controlFrame3.pack(side=LEFT,fill=Y)
		
		self.controlFrame4=Frame(self.midframe,bg='#fff')
		self.controlFrame4.pack(side=LEFT,fill=Y)
		
		self.controlFrame5=Frame(self.midframe,bg='#fff')
		self.controlFrame5.pack(side=LEFT,fill=Y)	
		
		self.controlFrame6=Frame(self.midframe,bg='#fff')
		self.controlFrame6.pack(side=LEFT,fill=Y)	
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Power on / reader link state variables
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		self.tagOnButton=Button(self.controlFrame1,width=12,text='Tag Power On',bg='#aaa')
		self.tagOnButton.pack(side=TOP)
		self.tagOnButton.bind('<Button-1>',self.tagPowerOn)
		
		#  some default reader parameters also go in this frame;  first Tari
		
		self.panelTariValue=IntVar()   # define a control variable for the Tari slider 

		#  limit values from standard in microseconds   std 1.0.9 table 6.5
		tslidermin=6   #  really  6.25 is the minimum, see update below...
		tslidermax=25
		self.TariSlider=Scale(self.controlFrame1,bg='#aaa',length=125,from_=tslidermin,label='Tari (microsec)',orient=HORIZONTAL, 
				relief=SUNKEN,to=tslidermax,tickinterval=5,bd=5,variable=self.panelTariValue)    # defines the slider to set Tari
		self.TariSlider.pack(side=TOP,fill=X)
		
		#   then length of binary 1 normalized;   from figure 6.1 of std
		self.xValue=DoubleVar()
		xslidermin=1.5
		xslidermax=2.0
		self.xSlider=Scale(self.controlFrame1,bg='#aaa',length=125,from_=xslidermin,label='binary 1 / Tari',orient=HORIZONTAL, 
				relief=SUNKEN,to=xslidermax,resolution=0.1,tickinterval=0.5,bd=5,variable=self.xValue)    # defines the slider to set length of binary 1
		self.xSlider.pack(side=TOP,fill=X)		
		
		#   then desired Miller subcarrier;   from figure 6.1 of std
		self.Mframe=Frame(self.controlFrame1,bg='#aaa',bd=3,relief=SUNKEN)
		self.Mframe.pack(side=TOP,fill=X)
		
		self.panelMValue=IntVar()	
		self.M1button=Radiobutton(self.Mframe,bg='#aaa',anchor=W,text='M=1',value=1,variable=self.panelMValue)
		self.M1button.pack(side=TOP,fill=X)
		self.M2button=Radiobutton(self.Mframe,bg='#aaa',anchor=W,text='M=2',value=2,variable=self.panelMValue)
		self.M2button.pack(side=TOP,fill=X)
		self.M4button=Radiobutton(self.Mframe,bg='#aaa',anchor=W,text='M=4',value=4,variable=self.panelMValue)
		self.M4button.pack(side=TOP,fill=X)
		self.M8button=Radiobutton(self.Mframe,bg='#aaa',anchor=W,text='M=8',value=8,variable=self.panelMValue)
		self.M8button.pack(side=TOP,fill=X)
		
		self.panelMValue.set(value=1)	
		
		#   divide ratio
		self.panelDRValue=IntVar()	#  encoded;  0=>  DR=8,  1=>  DR=64/3
		self.DR0button=Radiobutton(self.controlFrame1,bg='#aaa',anchor=W,text='DR=8',value=0,variable=self.panelDRValue)
		self.DR0button.pack(side=TOP,fill=X)
		self.DR1button=Radiobutton(self.controlFrame1,bg='#aaa',anchor=W,text='DR=64/3',value=1,variable=self.panelDRValue)
		self.DR1button.pack(side=TOP,fill=X)		
		
		#   TRcal    (proportional to the length of the minimal tag symbol Tpri)
		self.panelTRcalnorm=DoubleVar()
		trslidermin=1.1
		trslidermax=3.0
		self.TRcalSlider=Scale(self.controlFrame1,bg='#aaa',length=125,from_=trslidermin,label='TRcal/RTcal',orient=HORIZONTAL, 
				relief=SUNKEN,to=trslidermax,resolution=0.1,tickinterval=0.5,variable=self.panelTRcalnorm)    # defines the slider to set  Tpri and uplink rate
		self.TRcalSlider.pack(side=TOP,fill=X)
		
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Query
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		
		self.QueryButton=Button(self.controlFrame2,width=12,text='Query',bg='#aaa')
		self.QueryButton.pack(side=TOP)
		self.QueryButton.bind('<Button-1>',self.tagQuery)	
		
		#   now set up input parameters...
		
		self.panelTRextValue=IntVar()
		self.TRextButton=Checkbutton(self.controlFrame2,width=15,text='pilot tone',variable=self.panelTRextValue,bg='#fff') 
		self.TRextButton.pack(side=TOP,fill=X)
		
		#   select flag state
		
		self.SLTarframe=Frame(self.controlFrame2,bg='#aaa',bd=3,relief=SUNKEN)
		self.SLTarframe.pack(side=TOP,fill=X)
		
		
		self.panelSLTarValue=IntVar()	#  encoded;  0=> all    2=>  not SL    3=>  SL enabled
		self.SLallbutton=Radiobutton(self.SLTarframe,bg='#aaa',anchor=W,text='any SL',value=0,variable=self.panelSLTarValue)
		self.SLallbutton.pack(side=TOP,fill=X)
		self.notSLbutton=Radiobutton(self.SLTarframe,bg='#aaa',anchor=W,text='~SL',value=2,variable=self.panelSLTarValue)
		self.notSLbutton.pack(side=TOP,fill=X)	
		self.SLenbutton=Radiobutton(self.SLTarframe,bg='#aaa',anchor=W,text='SL',value=3,variable=self.panelSLTarValue)
		self.SLenbutton.pack(side=TOP,fill=X)			
		
		#   session for this Query
				
		self.panelSessionValue=IntVar()	
		self.Session0button=Radiobutton(self.controlFrame2,bg='#aaa',anchor=W,text='Session 0',value=0,variable=self.panelSessionValue)
		self.Session0button.pack(side=TOP,fill=X)
		self.Session1button=Radiobutton(self.controlFrame2,bg='#aaa',anchor=W,text='Session 1',value=1,variable=self.panelSessionValue)
		self.Session1button.pack(side=TOP,fill=X)	
		self.Session2button=Radiobutton(self.controlFrame2,bg='#aaa',anchor=W,text='Session 2',value=2,variable=self.panelSessionValue)
		self.Session2button.pack(side=TOP,fill=X)			
		self.Session3button=Radiobutton(self.controlFrame2,bg='#aaa',anchor=W,text='Session 3',value=3,variable=self.panelSessionValue)
		self.Session3button.pack(side=TOP,fill=X)					
		
		#   target for this Query
		
		self.panelTargetFrame=Frame(self.controlFrame2,bg='#aaa',bd=3,relief=SUNKEN)
		self.panelTargetFrame.pack(side=TOP,fill=X)
			
		self.panelTargetValue=IntVar()	
		self.TargetAbutton=Radiobutton(self.panelTargetFrame,bg='#aaa',anchor=W,text='Target = A',value=0,variable=self.panelTargetValue)
		self.TargetAbutton.pack(side=TOP,fill=X)
		self.TargetBbutton=Radiobutton(self.panelTargetFrame,bg='#aaa',anchor=W,text='Target = B',value=1,variable=self.panelTargetValue)
		self.TargetBbutton.pack(side=TOP,fill=X)		
		
		#   Q value    
		self.panelQValue=IntVar()
		Qslidermin=0
		Qslidermax=15
		self.panelQslider=Scale(self.controlFrame2,bg='#aaa',length=125,from_=Qslidermin,label='Q',orient=HORIZONTAL, 
				relief=SUNKEN,to=Qslidermax,tickinterval=5,variable=self.panelQValue)    # defines the slider to set Q
		self.panelQslider.pack(side=TOP,fill=X)
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	QueryRep
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.QRepFrame=Frame(self.controlFrame3,bg='#aaa',bd=3,relief=SUNKEN)
		self.QRepFrame.pack(side=TOP,fill=X)	
		
		#   Query Rep button
		self.QueryRepButton=Button(self.QRepFrame,width=12,text='QueryRep',bg='#aaa')
		self.QueryRepButton.pack(side=TOP)
		self.QueryRepButton.bind('<Button-1>',self.tagQueryRep)
		
		#  Session for Query Rep			
		self.panelRepSessionValue=IntVar()	
		self.RepSession0button=Radiobutton(self.QRepFrame,bg='#aaa',anchor=W,text='Session 0',value=0,variable=self.panelRepSessionValue)
		self.RepSession0button.pack(side=TOP,fill=X)
		self.RepSession1button=Radiobutton(self.QRepFrame,bg='#aaa',anchor=W,text='Session 1',value=1,variable=self.panelRepSessionValue)
		self.RepSession1button.pack(side=TOP,fill=X)	
		self.RepSession2button=Radiobutton(self.QRepFrame,bg='#aaa',anchor=W,text='Session 2',value=2,variable=self.panelRepSessionValue)
		self.RepSession2button.pack(side=TOP,fill=X)			
		self.RepSession3button=Radiobutton(self.QRepFrame,bg='#aaa',anchor=W,text='Session 3',value=3,variable=self.panelRepSessionValue)
		self.RepSession3button.pack(side=TOP,fill=X)					
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	QueryAdjust
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.QAdjFrame=Frame(self.controlFrame3,bg='#aaa',bd=3,relief=SUNKEN)
		self.QAdjFrame.pack(side=TOP,fill=X)	
		
		#  Query Adjust button
		self.QueryAdjButton=Button(self.QRepFrame,width=12,text='QueryAdjust',bg='#aaa')
		self.QueryAdjButton.pack(side=TOP)
		self.QueryAdjButton.bind('<Button-1>',self.tagQueryAdjust)
		
		#  session selection for Query Adjust				
		self.panelAdjSessionValue=IntVar()	
		self.AdjSession0button=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='Session 0',value=0,variable=self.panelAdjSessionValue)
		self.AdjSession0button.pack(side=TOP,fill=X)
		self.AdjSession1button=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='Session 1',value=1,variable=self.panelAdjSessionValue)
		self.AdjSession1button.pack(side=TOP,fill=X)	
		self.AdjSession2button=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='Session 2',value=2,variable=self.panelAdjSessionValue)
		self.AdjSession2button.pack(side=TOP,fill=X)			
		self.AdjSession3button=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='Session 3',value=3,variable=self.panelAdjSessionValue)
		self.AdjSession3button.pack(side=TOP,fill=X)					
		
		#  up, down, or no change?
		
		self.panelUpDnFrame=Frame(self.QAdjFrame,bg='#aaa',bd=3,relief=SUNKEN)
		self.panelUpDnFrame.pack(side=TOP,fill=X)
			
		self.panelQadjValue=IntVar()	
		self.QUpButton=Radiobutton(self.panelUpDnFrame,bg='#aaa',anchor=W,text='Q = Q+1',value=0,variable=self.panelQadjValue)
		self.QUpButton.pack(side=TOP,fill=X)
		self.QsameButton=Radiobutton(self.panelUpDnFrame,bg='#aaa',anchor=W,text='Q=Q',value=1,variable=self.panelQadjValue)
		self.QsameButton.pack(side=TOP,fill=X)
		self.QDnButton=Radiobutton(self.panelUpDnFrame,bg='#aaa',anchor=W,text='Q=Q-1',value=2,variable=self.panelQadjValue)
		self.QDnButton.pack(side=TOP,fill=X)	
		

		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Req_RN
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		#  Req_RN button
		self.ReqRNButton=Button(self.QAdjFrame,width=12,text='Request RN',bg='#aaa')
		self.ReqRNButton.pack(side=TOP)
		self.ReqRNButton.bind('<Button-1>',self.tagReq_RN)
		
		self.Req_RNEntry=Entry(self.QAdjFrame,width=8,bd=2,relief=SUNKEN)
		self.Req_RNEntry.pack(side=TOP)
		self.Req_RNEntry.insert(0,'0x0000')
		
		#  are we getting a handle or a cover word?  
						
		self.panelReqRNtype=IntVar()	
		self.ReqRNhandle=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='handle',value=0,variable=self.panelReqRNtype)
		self.ReqRNhandle.pack(side=TOP,fill=X)
		self.ReqRNcover=Radiobutton(self.QAdjFrame,bg='#aaa',anchor=W,text='cover',value=1,variable=self.panelReqRNtype)
		self.ReqRNcover.pack(side=TOP,fill=X)	
	

		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Handle
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.HandleLabel=Label(self.QAdjFrame,width=12,bd=2,relief=SUNKEN,text=' Tag handle')
		self.HandleLabel.pack(side=TOP)


		self.HandleEntry=Entry(self.QAdjFrame,width=6,bd=2,relief=SUNKEN)
		self.HandleEntry.pack(side=TOP)
		self.HandleEntry.insert(0,'0x0000')	
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	ACK
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.ACKFrame=Frame(self.controlFrame2,bg='#aaa',bd=3,relief=SUNKEN)
		self.ACKFrame.pack(side=TOP,fill=X)	
		
		# ACK button
		self.ACKButton=Button(self.ACKFrame,width=12,text='ACK',bg='#aaa')
		self.ACKButton.pack(side=TOP)
		self.ACKButton.bind('<Button-1>',self.tagACK)
		
		self.ACKbottomFrame=Frame(self.ACKFrame,bg='#aaa')
		self.ACKbottomFrame.pack(side=TOP)
		
		self.ACKEntry=Entry(self.ACKbottomFrame,width=6,bd=2,relief=SUNKEN)
		self.ACKEntry.pack(side=LEFT)	
		self.ACKEntry.insert(0,'0x0000')
		
		self.GetAckValueButton=Button(self.ACKbottomFrame,width=6,text='Get',bg='#aaa')
		self.GetAckValueButton.pack(side=RIGHT)
		self.GetAckValueButton.bind('<Button-1>',self.getAckValue)


		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	NAK
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.NAKFrame=Frame(self.controlFrame2,bg='#aaa',bd=3,relief=SUNKEN)
		self.NAKFrame.pack(side=TOP,fill=X)	
		
		# NAK button
		self.NAKButton=Button(self.NAKFrame,width=12,text='NAK',bg='#aaa')
		self.NAKButton.pack(side=TOP)
		self.NAKButton.bind('<Button-1>',self.tagNAK)
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Select
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.SelectFrame=Frame(self.controlFrame4,bg='#aaa',bd=3,relief=SUNKEN)
		self.SelectFrame.pack(side=TOP,fill=X)	
		
		# Select button
		self.SelectButton=Button(self.SelectFrame,width=12,text='Select',bg='#aaa')
		self.SelectButton.pack(side=TOP)
		self.SelectButton.bind('<Button-1>',self.tagSelect)	
		
		self.SelectFrameLeft=Frame(self.SelectFrame,bg='#aaa')
		self.SelectFrameLeft.pack(side=LEFT,fill=Y)
		
		self.SelectFrameRight=Frame(self.SelectFrame,bg='#aaa')
		self.SelectFrameRight.pack(side=RIGHT,fill=Y)
		
		#   label Select Target
		self.SelTargetLabel=Label(self.SelectFrameLeft,text='Select Target')		
		self.SelTargetLabel.pack(side=TOP,fill=X)
		
		#  Select Target Buttons:  sessions 0-3 or SL flag
		self.panelSelSessionValue=IntVar()	
		self.SelSLbutton=Radiobutton(self.SelectFrameLeft,bg='#aaa',anchor=W,text='SL Flag',value=4,variable=self.panelSelSessionValue)
		self.SelSLbutton.pack(side=TOP,fill=X)
		self.SelSession0button=Radiobutton(self.SelectFrameLeft,bg='#aaa',anchor=W,text='Session 0',value=0,variable=self.panelSelSessionValue)
		self.SelSession0button.pack(side=TOP,fill=X)
		self.SelSession1button=Radiobutton(self.SelectFrameLeft,bg='#aaa',anchor=W,text='Session 1',value=1,variable=self.panelSelSessionValue)
		self.SelSession1button.pack(side=TOP,fill=X)	
		self.SelSession2button=Radiobutton(self.SelectFrameLeft,bg='#aaa',anchor=W,text='Session 2',value=2,variable=self.panelSelSessionValue)
		self.SelSession2button.pack(side=TOP,fill=X)			
		self.SelSession3button=Radiobutton(self.SelectFrameLeft,bg='#aaa',anchor=W,text='Session 3',value=3,variable=self.panelSelSessionValue)
		self.SelSession3button.pack(side=TOP,fill=X)	
		
		#  make a frame for the action buttons
		self.ActionFrame=Frame(self.SelectFrameLeft,bg='#aaa',bd=3,relief=SUNKEN)
		self.ActionFrame.pack(side=TOP,fill=X)
		
		self.SelActionLabel=Label(self.ActionFrame,text='  match | no match')		
		self.SelActionLabel.pack(side=TOP)
		
		#  make the action radio buttons 
		self.panelActionValue=IntVar()
		self.SelAction0button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='assert        |  deassert',value=0,variable=self.panelActionValue)
		self.SelAction0button.pack(side=TOP,fill=X)		
		self.SelAction1button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='assert        | do nothing',value=1,variable=self.panelActionValue)
		self.SelAction1button.pack(side=TOP,fill=X)	
		self.SelAction2button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='do nothing | deassert',value=2,variable=self.panelActionValue)
		self.SelAction2button.pack(side=TOP,fill=X)	
		self.SelAction3button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='toggle        | do nothing',value=3,variable=self.panelActionValue)
		self.SelAction3button.pack(side=TOP,fill=X)	
		self.SelAction4button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='deassert     | assert',value=4,variable=self.panelActionValue)
		self.SelAction4button.pack(side=TOP,fill=X)	
		self.SelAction5button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='deassert     | do nothing',value=5,variable=self.panelActionValue)
		self.SelAction5button.pack(side=TOP,fill=X)	
		self.SelAction6button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='do nothing | assert',value=6,variable=self.panelActionValue)
		self.SelAction6button.pack(side=TOP,fill=X)	
		self.SelAction7button=Radiobutton(self.ActionFrame,bg='#aaa',anchor=W,text='do nothing | toggle',value=7,variable=self.panelActionValue)
		self.SelAction7button.pack(side=TOP,fill=X)			
		
		#  make the membank radio buttons 
		self.panelSelMemBankValue=IntVar()
		self.panelSelMemBankValue.set(1)
		self.SelMemBank1button=Radiobutton(self.SelectFrameRight,bg='#aaa',anchor=W,text='EPC bank',value=1,variable=self.panelSelMemBankValue)
		self.SelMemBank1button.pack(side=TOP,fill=X)		
		
		self.SelMemBank2button=Radiobutton(self.SelectFrameRight,bg='#aaa',anchor=W,text='tag ID bank',value=2,variable=self.panelSelMemBankValue)
		self.SelMemBank2button.pack(side=TOP,fill=X)			
		
		self.SelMemBank3button=Radiobutton(self.SelectFrameRight,bg='#aaa',anchor=W,text='user bank',value=3,variable=self.panelSelMemBankValue)
		self.SelMemBank3button.pack(side=TOP,fill=X)	
		
		self.PtrValue=IntVar()
		Ptrslidermin=0
		Ptrslidermax=256
		self.PtrSlider=Scale(self.SelectFrameRight,bg='#aaa',length=150,from_=Ptrslidermin,label='Pointer',orient=HORIZONTAL, 
				relief=SUNKEN,to=Ptrslidermax,resolution=8,tickinterval=128,bd=5,variable=self.PtrValue)    # defines the Pointer slider
		self.PtrSlider.pack(side=TOP,fill=X)
		
		self.LenValue=IntVar()
		Lenslidermin=0
		Lenslidermax=32    #  standard allows up to 256 bits but we won't implement that for now
		self.LenSlider=Scale(self.SelectFrameRight,bg='#aaa',length=150,from_=Lenslidermin,label='Length',orient=HORIZONTAL, 
				relief=SUNKEN,to=Lenslidermax,resolution=4,tickinterval=32,bd=5,variable=self.LenValue)    # defines the Length slider
		self.LenSlider.pack(side=TOP,fill=X)		
		
		self.MaskBits=Entry(self.SelectFrameRight,width=16,relief=SUNKEN,bd=3)
		self.MaskBits.pack(side=TOP,fill=X)
		
		self.NoTruncate=Label(self.SelectFrameRight,text='mask as hex',width=20)
		self.NoTruncate.pack(side=TOP)	
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Read / Write
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		#  make a frame for the Read command options
		
		self.ReadFrame=Frame(self.controlFrame5,bg='#aaa',bd=3,relief=SUNKEN)
		self.ReadFrame.pack(side=TOP,fill=X)	
		
		# Read button
		self.ReadButton=Button(self.ReadFrame,width=12,text='Read',bg='#aaa')
		self.ReadButton.pack(side=TOP)
		self.ReadButton.bind('<Button-1>',self.tagRead)
		
		#  make the membank radio buttons 
		self.panelReadMemBankValue=IntVar()
		
		self.ReadMemBank0button=Radiobutton(self.ReadFrame,bg='#aaa',anchor=W,text='password bank',value=0,variable=self.panelReadMemBankValue)
		self.ReadMemBank0button.pack(side=TOP,fill=X)	
		
		self.ReadMemBank1button=Radiobutton(self.ReadFrame,bg='#aaa',anchor=W,text='EPC bank',value=1,variable=self.panelReadMemBankValue)
		self.ReadMemBank1button.pack(side=TOP,fill=X)		
		
		self.ReadMemBank2button=Radiobutton(self.ReadFrame,bg='#aaa',anchor=W,text='tag ID bank',value=2,variable=self.panelReadMemBankValue)
		self.ReadMemBank2button.pack(side=TOP,fill=X)			
		
		self.ReadMemBank3button=Radiobutton(self.ReadFrame,bg='#aaa',anchor=W,text='user bank',value=3,variable=self.panelReadMemBankValue)
		self.ReadMemBank3button.pack(side=TOP,fill=X)	
				
		self.WordPtrValue=IntVar()
		Ptrslidermin=0
		Ptrslidermax=7
		self.WordPtrSlider=Scale(self.ReadFrame,bg='#aaa',length=100,from_=Ptrslidermin,orient=HORIZONTAL, label='starting word',
				relief=SUNKEN,to=Ptrslidermax,resolution=1,tickinterval=4,bd=5,variable=self.WordPtrValue)    # defines the Pointer slider
		self.WordPtrSlider.pack(side=TOP,fill=X)
		
		self.WordLenValue=IntVar()
		Lenslidermin=0
		Lenslidermax=8    #  assuming only 8 words max
		self.WordLenSlider=Scale(self.ReadFrame,bg='#aaa',length=100,from_=Lenslidermin,label='words to read',orient=HORIZONTAL, 
				relief=SUNKEN,to=Lenslidermax,resolution=1,tickinterval=4,bd=5,variable=self.WordLenValue)    # defines the Length slider
		self.WordLenSlider.pack(side=TOP,fill=X)	
		
		#   write button
		
		self.WriteButton=Button(self.ReadFrame,width=12,text='Write word',bg='#aaa')
		self.WriteButton.pack(side=TOP)
		self.WriteButton.bind('<Button-1>',self.tagWrite)	
		
		#  membank and wordptr are the same for Read and Write
		
		#  label the data
		self.WriteDataLabel=Label(self.ReadFrame,width=14,bd=2,relief=SUNKEN,text=' Word to write')
		self.WriteDataLabel.pack(side=TOP)
		
		#  place to enter the data to write
		self.WriteWord=Entry(self.ReadFrame,width=6,bd=2,relief=SUNKEN)
		self.WriteWord.pack(side=TOP)
		self.WriteWord.insert(0,'0x0000')	
		
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Lock
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
		self.lockFrame=Frame(self.controlFrame6,bg='#aaa',bd=3,relief=SUNKEN)
		self.lockFrame.pack(side=LEFT,fill=Y)
		
		self.LockButton=Button(self.lockFrame,width=12,text='Lock',bg='#aaa')
		self.LockButton.pack(side=TOP)
		self.LockButton.bind('<Button-1>',self.tagLock)
		
		self.labelLock=Label(self.lockFrame,text='enable          action',height=1, width=18)
		self.labelLock.pack(side=TOP)
		
		#   make frames for the individual check buttons
		#
		self.killLockFrame=Frame(self.lockFrame)
		self.killLockFrame.pack(side=TOP,fill=Y)
		self.killpermaLockFrame=Frame(self.lockFrame)
		self.killpermaLockFrame.pack(side=TOP,fill=Y)
		self.accessLockFrame=Frame(self.lockFrame)
		self.accessLockFrame.pack(side=TOP,fill=Y)
		self.accesspermaLockFrame=Frame(self.lockFrame)
		self.accesspermaLockFrame.pack(side=TOP,fill=Y)
		self.EPCLockFrame=Frame(self.lockFrame)
		self.EPCLockFrame.pack(side=TOP,fill=Y)
		self.EPCpermaLockFrame=Frame(self.lockFrame)
		self.EPCpermaLockFrame.pack(side=TOP,fill=Y)
		self.TIDLockFrame=Frame(self.lockFrame)
		self.TIDLockFrame.pack(side=TOP,fill=Y)
		self.TIDpermaLockFrame=Frame(self.lockFrame)
		self.TIDpermaLockFrame.pack(side=TOP,fill=Y)
		self.userLockFrame=Frame(self.lockFrame)
		self.userLockFrame.pack(side=TOP,fill=Y)
		self.userpermaLockFrame=Frame(self.lockFrame)
		self.userpermaLockFrame.pack(side=TOP,fill=Y)	
		
		#  now make checkbuttons for the enable and action fields
		#   KILL lock
		self.killLockEnableValue=IntVar()
		self.killLockEnableButton=Checkbutton(self.killLockFrame,width=10,text='KILL pwd',variable=self.killLockEnableValue,bg='#fff') 
		self.killLockEnableButton.pack(side=LEFT)
		
		self.killLockValue=IntVar()
		self.killLockButton=Checkbutton(self.killLockFrame,width=2,variable=self.killLockValue,bg='#fff') 
		self.killLockButton.pack(side=LEFT)
		
		#  KILL permalock
		self.killpermaLockEnableValue=IntVar()
		self.killpermaLockEnableButton=Checkbutton(self.killpermaLockFrame,width=10,text='permalock',variable=self.killpermaLockEnableValue,bg='#fff') 
		self.killpermaLockEnableButton.pack(side=LEFT)
		
		self.killpermaLockValue=IntVar()
		self.killpermaLockButton=Checkbutton(self.killpermaLockFrame,width=2,variable=self.killpermaLockValue,bg='#fff') 
		self.killpermaLockButton.pack(side=LEFT)		
		
		#  ACCESS lock
		self.accessLockEnableValue=IntVar()
		self.accessLockEnableButton=Checkbutton(self.accessLockFrame,width=10,text='ACCESS pwd',variable=self.accessLockEnableValue,bg='#fff') 
		self.accessLockEnableButton.pack(side=LEFT)
		
		self.accessLockValue=IntVar()
		self.accessLockButton=Checkbutton(self.accessLockFrame,width=2,variable=self.accessLockValue,bg='#fff') 
		self.accessLockButton.pack(side=LEFT)				

		#  ACCESS permalock
		self.accesspermaLockEnableValue=IntVar()
		self.accesspermaLockEnableButton=Checkbutton(self.accesspermaLockFrame,width=10,text='permalock',variable=self.accesspermaLockEnableValue,bg='#fff') 
		self.accesspermaLockEnableButton.pack(side=LEFT)
		
		self.accesspermaLockValue=IntVar()
		self.accesspermaLockButton=Checkbutton(self.accesspermaLockFrame,width=2,variable=self.accesspermaLockValue,bg='#fff') 
		self.accesspermaLockButton.pack(side=LEFT)	
		
		#  EPC bank	
		self.EPCLockEnableValue=IntVar()
		self.EPCLockEnableButton=Checkbutton(self.EPCLockFrame,width=10,text='EPC bank',variable=self.EPCLockEnableValue,bg='#fff') 
		self.EPCLockEnableButton.pack(side=LEFT)
		
		self.EPCLockValue=IntVar()
		self.EPCLockButton=Checkbutton(self.EPCLockFrame,width=2,variable=self.EPCLockValue,bg='#fff') 
		self.EPCLockButton.pack(side=LEFT)	
		
		#  EPC permalock
		self.EPCpermaLockEnableValue=IntVar()
		self.EPCpermaLockEnableButton=Checkbutton(self.EPCpermaLockFrame,width=10,text='permalock',variable=self.EPCpermaLockEnableValue,bg='#fff') 
		self.EPCpermaLockEnableButton.pack(side=LEFT)
		
		self.EPCpermaLockValue=IntVar()
		self.EPCpermaLockButton=Checkbutton(self.EPCpermaLockFrame,width=2,variable=self.EPCpermaLockValue,bg='#fff') 
		self.EPCpermaLockButton.pack(side=LEFT)	
		
		#  TID bank	
		self.TIDLockEnableValue=IntVar()
		self.TIDLockEnableButton=Checkbutton(self.TIDLockFrame,width=10,text='TID bank',variable=self.TIDLockEnableValue,bg='#fff') 
		self.TIDLockEnableButton.pack(side=LEFT)
		
		self.TIDLockValue=IntVar()
		self.TIDLockButton=Checkbutton(self.TIDLockFrame,width=2,variable=self.TIDLockValue,bg='#fff') 
		self.TIDLockButton.pack(side=LEFT)	
		
		#  TID permalock
		self.TIDpermaLockEnableValue=IntVar()
		self.TIDpermaLockEnableButton=Checkbutton(self.TIDpermaLockFrame,width=10,text='permalock',variable=self.TIDpermaLockEnableValue,bg='#fff') 
		self.TIDpermaLockEnableButton.pack(side=LEFT)
		
		self.TIDpermaLockValue=IntVar()
		self.TIDpermaLockButton=Checkbutton(self.TIDpermaLockFrame,width=2,variable=self.TIDpermaLockValue,bg='#fff') 
		self.TIDpermaLockButton.pack(side=LEFT)	

		
		#  user bank	
		self.userLockEnableValue=IntVar()
		self.userLockEnableButton=Checkbutton(self.userLockFrame,width=10,text='user bank',variable=self.userLockEnableValue,bg='#fff') 
		self.userLockEnableButton.pack(side=LEFT)
		
		self.userLockValue=IntVar()
		self.userLockButton=Checkbutton(self.userLockFrame,width=2,variable=self.userLockValue,bg='#fff') 
		self.userLockButton.pack(side=LEFT)	
		
		#  user permalock
		self.userpermaLockEnableValue=IntVar()
		self.userpermaLockEnableButton=Checkbutton(self.userpermaLockFrame,width=10,text='permalock',variable=self.userpermaLockEnableValue,bg='#fff') 
		self.userpermaLockEnableButton.pack(side=LEFT)
		
		self.userpermaLockValue=IntVar()
		self.userpermaLockButton=Checkbutton(self.userpermaLockFrame,width=2,variable=self.userpermaLockValue,bg='#fff') 
		self.userpermaLockButton.pack(side=LEFT)			
					
		
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		#	Display reply
		# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		self.ReplyFrame=Frame(self.bottomframe,bg='#aaa',bd=3,relief=SUNKEN)
		self.ReplyFrame.pack(side=LEFT,fill=Y)
		
		self.ReplyLabel=Label(self.ReplyFrame,text=' TAG REPLY:',height=1,width=7,padx=6)
		self.ReplyLabel.pack(side=LEFT)
		
		self.ReplyValueText=Text(self.ReplyFrame,height=1,width=64,relief=SUNKEN,borderwidth=2)
		self.ReplyValueText.pack(side=LEFT)	
		
		self.timeLabel=Label(self.ReplyFrame,text=' Time:',height=1,width=7,padx=6)
		self.timeLabel.pack(side=LEFT)		
		
		self.timeValue=Text(self.ReplyFrame,height=1,width=12,relief=SUNKEN,borderwidth=2)
		self.timeValue.pack(side=LEFT)			
		
		
		self.updateDisplay()
		
		#   end __init__   class G2_LogicalTag_controlPanel
	


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	update display
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
	def updateDisplay(self):
		'''This routine simply updates all the display boxes.'''
		
		self.SLstatus.delete(1.0,END)		# clear widget
		self.SLstatus.insert(1.0,self.testTag.SL)	# update
		
		self.S0status.delete(1.0,END)				# clear widget
		self.S0status.insert(1.0,self.testTag.sessionFlags[0])	# update

		self.S1status.delete(1.0,END)				# clear widget
		self.S1status.insert(1.0,self.testTag.sessionFlags[1])	# update
		
		self.S2status.delete(1.0,END)				# clear widget
		self.S2status.insert(1.0,self.testTag.sessionFlags[2])	# update
		
		self.S3status.delete(1.0,END)				# clear widget
		self.S3status.insert(1.0,self.testTag.sessionFlags[3])	# update

		self.currentSession.delete(1.0,END)				# clear widget
		self.currentSession.insert(1.0,self.testTag.lastSession)	#  update
		
		self.QRNValue.delete(1.0,END)				# clear widget
		self.QRNValue.insert(1.0,hex(self.testTag.QRN))		# update
		
		self.handleValue.delete(1.0,END)				# clear widget
		self.handleValue.insert(1.0,hex(self.testTag.handle))	# update
		
		self.counterValue.delete(1.0,END)					# clear widget
		self.counterValue.insert(1.0,hex(self.testTag.slotCounter))	# update
				
		self.stateValue.delete(1.0,END)				# clear widget
		self.stateValue.insert(1.0,self.testTag.state)		# update
				
		self.QValue.delete(1.0,END)					# clear widget
		self.QValue.insert(1.0,self.testTag.currentQ)		# update
				
		self.RTcalValue.delete(1.0,END)				# clear widget
		self.RTcalValue.insert(1.0,self.testTag.RTcal)		# update
		
		self.TRcalValue.delete(1.0,END)				# clear widget
		self.TRcalValue.insert(1.0,self.testTag.TRcal)		# update

		self.DRValue.delete(1.0,END)				# clear widget
		self.DRValue.insert(1.0,self.testTag.DivideRatio)		# update		

		self.MValue.delete(1.0,END)					# clear widget
		self.MValue.insert(1.0,self.testTag.Mvalue)			# update		

		self.TariValue.delete(1.0,END)				# clear widget
		self.TariValue.insert(1.0,self.testTag.Tari	)		# update
		
		self.TRextValue.delete(1.0,END)				# clear widget
		self.TRextValue.insert(1.0,self.testTag.TRext)		# update
		
		self.LFValue.delete(1.0,END)					# clear widget
		self.LFValue.insert(1.0,int(self.testTag.LinkFreq))	# update		
		
		self.TpriValue.delete(1.0,END)				# clear widget
		self.TpriValue.insert(1.0,self.testTag.Tpri)			# update			
		
		self.T1Value.delete(1.0,END)				# clear widget
		self.T1Value.insert(1.0,int(self.testTag.T1))		# update
		
		self.T2maxValue.delete(1.0,END)				# clear widget
		self.T2maxValue.insert(1.0,int(self.testTag.T2max))	# update	

		#   memory bank displays:   first clear all the widgets
		self.Bank0Value.delete(1.0,END)				# clear widget		
		self.Bank1Value.delete(1.0,END)				# clear widget	
		self.Bank2Value.delete(1.0,END)				# clear widget	
		self.Bank3Value.delete(1.0,END)				# clear widget	
		
		#  now read the banks
		for i in range(0,8,1):
			bank0word=256*self.testTag.tagMemory.readMemoryByte(0,i,0)+self.testTag.tagMemory.readMemoryByte(0,i,1)
			bank1word=256*self.testTag.tagMemory.readMemoryByte(1,i,0)+self.testTag.tagMemory.readMemoryByte(1,i,1)
			bank2word=256*self.testTag.tagMemory.readMemoryByte(2,i,0)+self.testTag.tagMemory.readMemoryByte(2,i,1)
			bank3word=256*self.testTag.tagMemory.readMemoryByte(3,i,0)+self.testTag.tagMemory.readMemoryByte(3,i,1)
			
			
			self.Bank0Value.insert(END,hex(bank0word)[2:]+'\n')
			self.Bank1Value.insert(END,hex(bank1word)[2:]+'\n')
			self.Bank2Value.insert(END,hex(bank2word)[2:]+'\n')
			self.Bank3Value.insert(END,hex(bank3word)[2:]+'\n')
		
		#  status of the lock bits
		
		self.KillLockValueDisplay.delete(1.0,END)						#clear widget
		self.KillLockValueDisplay.insert(1.0,self.testTag.tagMemory.lockKill)			# update
		
		self.KillPermaLockValueDisplay.delete(1.0,END)						#clear widget
		self.KillPermaLockValueDisplay.insert(1.0,self.testTag.tagMemory.permalockKill)	        # update

		self.AccessLockValueDisplay.delete(1.0,END)						#clear widget
		self.AccessLockValueDisplay.insert(1.0,self.testTag.tagMemory.lockAccess)		# update
		
		self.AccessPermaLockValueDisplay.delete(1.0,END)					#clear widget
		self.AccessPermaLockValueDisplay.insert(1.0,self.testTag.tagMemory.permalockAccess)     # update
		
		self.EPCLockValueDisplay.delete(1.0,END)						#clear widget
		self.EPCLockValueDisplay.insert(1.0,self.testTag.tagMemory.lockBank[1])		        # update
		
		self.EPCPermaLockValueDisplay.delete(1.0,END)						#clear widget
		self.EPCPermaLockValueDisplay.insert(1.0,self.testTag.tagMemory.permalockBank[1])	# update
				
		self.TIDLockValueDisplay.delete(1.0,END)						#clear widget
		self.TIDLockValueDisplay.insert(1.0,self.testTag.tagMemory.lockBank[2])		        # update
		
		self.TIDPermaLockValueDisplay.delete(1.0,END)						#clear widget
		self.TIDPermaLockValueDisplay.insert(1.0,self.testTag.tagMemory.permalockBank[2])	# update
						
		self.userLockValueDisplay.delete(1.0,END)						#clear widget
		self.userLockValueDisplay.insert(1.0,self.testTag.tagMemory.lockBank[3])		# update
		
		self.userPermaLockValueDisplay.delete(1.0,END)						#clear widget
		self.userPermaLockValueDisplay.insert(1.0,self.testTag.tagMemory.permalockBank[3])      # update
		
		
		#  tagWorld time
		self.timeValue.delete(1.0,END)		#  clear widget
		self.timeValue.insert(1.0,int(self.tagWorldTime))
			

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	support functions
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	def commandDuration(self,Command,Tari,RTcal,TRcal,dataBits):
		''' This support function computes the duration of a command.
                We assume that command and data bits average to equal numbers
                of 0 and 1, so that the duration of each bit is taken to be
                RTcal/2.  The duration of each command is of the form
                duration = 12.5+Tari+(x+databits/2)*RTcal +y*TRcal
                where x varies depending on the command, and y is 1 for a Query,
                0 for anything else.  In the case of commands with variable data
                (that is, Select and BlockWrite), the variable data part only
                should be sent as dataBits, which is 0 for other commands.'''

		if Command=='Select':
			duration=12.5+Tari+(23.5+dataBits/2.0)*RTcal
		elif Command=='Query':
			duration=12.5+Tari+12*RTcal+TRcal
		elif Command=='QueryAdjust':
			duration=12.5+Tari+5.5*RTcal
		elif Command=='QueryRep':
			duration=12.5+Tari+3*RTcal
		elif Command=='ACK':
			duration=12.5+Tari+5.5*RTcal
		elif Command=='NAK':
			duration=12.5+Tari+5*RTcal
		elif Command=='Req_RN':
			duration=12.5+Tari+21*RTcal
		elif Command=='Read':
			duration=12.5+Tari+30*RTcal
		elif Command=='Write':
			duration=12.5+Tari+30*RTcal
		elif Command=='Access':
			duration=12.5+Tari+29*RTcal
		elif Command=='BlockWrite':
			duration=12.5+Tari+(29+dataBits/2.0)*RTcal
		elif Command=='BlockErase':
			duration=12.5+Tari+30*RTcal
		elif Command=='Lock':
			duration=12.5+Tari+31*RTcal
		elif Command=='Kill':
			duration=12.5+Tari+30.5*RTcal

		print 'in commandDuration, command was:', Command,' and duration was:',duration,' microseconds'

		return duration

        #  end commandDuration


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	control handlers
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagPowerOn
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagPowerOn(self,event):	
		'''This handler turns the tag on or off. The turn-on operation takes
                1500 microseconds; turn off is treated as instant.'''
		
		if self.testTag.state=='off':
			self.tagOnButton.config(text='Tag Power Off')
			self.CommandTime[0]=self.tagWorldTime                   #  start of command
			self.tagWorldTime=self.tagWorldTime+1500		#  standard 1.0.9 table 6.7
			self.CommandTime[1]=self.tagWorldTime                   #  end of command
			returnlist=self.testTag.PowerOn(self.CommandTime)
		else:
			self.CommandTime[0]=self.tagWorldTime
			self.CommandTime[1]=self.tagWorldTime
			returnlist=self.testTag.PowerLost(self.CommandTime)
			self.tagOnButton.config(text='Tag Power On')
		
		self.updateDisplay()

	# end tagPowerOn


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagQuery
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagQuery(self,event):	
		'''Call the Query function on the tag.'''
		Tari=self.panelTariValue.get()
		if Tari==6:
			Tari=6.25		#  impose the requirement of the standard v 1.0.9
		self.Tari=Tari			#  set the current value for this reader
		xValue=self.xValue.get()
		RTcal=(1.0+xValue)*Tari
		self.RTcal=RTcal		#  set the current value for this reader
		if self.panelDRValue.get()==0:
			DR=8
		if self.panelDRValue.get()==1:
			DR=64.0/3.0
		M=self.panelMValue.get()
		TRcal=self.panelTRcalnorm.get()*RTcal
		self.TRcal=TRcal		#  set the current value for this reader
		TRext=self.panelTRextValue.get()
		SL=self.panelSLTarValue.get()
		Session=self.panelSessionValue.get()
		Target=self.panelTargetValue.get()
		Q=self.panelQValue.get()

		#  set the times for the start and end of the Query command

		self.tagWorldTime=self.tagWorldTime+2*RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Query',Tari,RTcal,TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		#  issue the command to the tag
		returnlist=self.testTag.Query(Tari,RTcal,TRcal,DR,M,TRext,SL,Session,Target,Q,'00000',self.CommandTime)
		
		self.ReplyValueText.delete(1.0,END)				# clear widget
		print 'returnlist is:', returnlist
		if returnlist[0]!='NULL':
			self.currQRN=returnlist[0]
			if self.currQRN>0xffff:	#  reply should be one hex word
				self.currQRN=0xffff	#  if not force it to a single word
			self.ReplyValueText.insert(1.0,hex(returnlist[0]))		# update
		else:
			self.ReplyValueText.insert(1.0,(returnlist[0]))
		self.tagWorldTime=returnlist[1][1]
		
		self.updateDisplay()

	#  end tagQuery
		
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagQueryRep
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagQueryRep(self,event):	
		'''Call the QueryRep function on the tag.'''

		Session=self.panelRepSessionValue.get()
		
		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('QueryRep',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime
		
		
		returnlist=self.testTag.QueryRep(Session,self.CommandTime)
		
		self.ReplyValueText.delete(1.0,END)				# clear widget
		if returnlist[0]!='NULL':
			self.currQRN=returnlist[0]
			if self.currQRN>0xffff:	#  reply should be one hex word
				self.currQRN=0xffff	#  if not force it to a single word
			self.ReplyValueText.insert(1.0,hex(returnlist[0]))		# update
		else:
			self.ReplyValueText.delete(1.0,END)
			self.ReplyValueText.insert(1.0,(returnlist[0]))
		
		self.tagWorldTime=returnlist[1][1]
		self.updateDisplay()

	#  end tagQueryRep


		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagQueryAdjust
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagQueryAdjust(self,event):	
		'''Call the Query Adjust function on the tag. ''' 		

		Session=self.panelAdjSessionValue.get()
		UpDnCoded=self.panelQadjValue.get()
							#   convert to arguments required by standard
		if UpDnCoded==0:
			UpDn=6
		elif UpDnCoded==1:
			UpDn=0
		elif UpDnCoded==2:
			UpDn=3

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('QueryAdjust',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime
		
		returnlist=self.testTag.QueryAdjust(Session,UpDn,self.CommandTime)
		
		self.ReplyValueText.delete(1.0,END)				# clear widget
		if returnlist[0]!='NULL':
			self.currQRN=returnlist[0]
			if self.currQRN>0xffff:	#  reply should be one hex word
				self.currQRN=0xffff	#  if not force it to a single word
			self.ReplyValueText.insert(1.0,hex(returnlist[0]))		# update
		else:
			self.ReplyValueText.insert(1.0,(returnlist[0]))
		
		self.tagWorldTime=returnlist[1][1]
		self.updateDisplay()

	#  end tagQueryAdjust


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagReq_RN
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

	def tagReq_RN(self,event):
		'''Call the Req_RN function on the tag.'''
		
		#  first figure out if we're getting a handle or a cover code.
		RNtype=self.panelReqRNtype.get()
		if RNtype==0:		#  it's a handle
			self.Req_RNEntry.delete(0,END)
			self.Req_RNEntry.insert(0,hex(self.currQRN))
		if RNtype==1:		#  it's a cover code
			self.Req_RNEntry.delete(0,END)
			self.Req_RNEntry.insert(0,hex(self.currHandle))
		#
		currRNValue=self.Req_RNEntry.get()	#  get the text in the entry box
		currRN=int(currRNValue,16)		#  convert the string to an integer

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Req_RN',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		returnlist=self.testTag.Req_RN(currRN,'0000000000000000',self.CommandTime)
		
		if returnlist[0]=='NULL':
			self.ReplyValueText.delete(1.0,END)
			self.ReplyValueText.insert(1.0,(returnlist[0]))		# update
		else:
			if RNtype==0: 
				self.currHandle=returnlist[0]	# we got a handle, update and display
				self.HandleEntry.delete(0,END)
				self.HandleEntry.insert(0,hex(self.currHandle))
			if RNtype==1: self.currCover=returnlist[0]	#  we got a cover word, update
			displayRN=hex(returnlist[0])	#  convert to hex string
			self.ReplyValueText.delete(1.0,END)	#  clear the reply window
			self.ReplyValueText.insert(1.0,displayRN)	#  insert the reply
			
			
		
		self.tagWorldTime=returnlist[1][1]
		self.updateDisplay()

        #  end tagReq_RN


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	getAckValue
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

	def getAckValue(self,event):
		'''This function grabs the most recent reply value from the variable ReplyValue and puts it into the 
		ACK function's entry field as a hex number.'''
		
		getValue=hex(self.currQRN)
		self.ACKEntry.delete(0,END)
		self.ACKEntry.insert(0,getValue)
		
				
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagACK
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagACK(self,event):	
		'''Call the ACK function on the tag.'''

		ACKValue=self.ACKEntry.get()	#  get the text in the entry box
		ACKRN=int(ACKValue,16)	#  convert the string to  an integer

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('ACK',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		returnlist=self.testTag.ACK(ACKRN,self.CommandTime)
		
		self.ReplyValueText.delete(1.0,END)				# clear widget
		if returnlist[0]=='NULL':
			self.ReplyValueText.insert(1.0,(returnlist[0]))		# update
		else:
			displaylist=self.Numbers_to_hex(returnlist[0])	#  convert to hex list
			cleaneduplist=self.Clean_up_word_list(displaylist)
			self.ReplyValueText.insert(1.0,cleaneduplist)
			
			#   OOOPS!!!   should also add a little routine to check the PC-EPC value against the CRC!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		self.tagWorldTime=returnlist[1][1]
		self.updateDisplay()
		
	#  end  tagACK


	def Numbers_to_hex(self,inputlist):
		'''This function converts a list of numbers to a list of strings showing them in hex format'''
		x=len(inputlist)
		outputlist=[]
		for y in range(0,x,1):
			outputlist=outputlist+[hex(inputlist[y])]
		return outputlist
	
	# end Bytes_to_hex


	def Clean_up_word_list(self,idlist):
		'''  This routine iterates through each element of an input list, presumed to be
		a list of hex word strings, and removes the leading '0x';  then it replaces
		the leading zeroes if missing, inserts blanks between words, and returns the result.'''

		idstring=' '
		for z in range(0,len(idlist),1):
			nextword=idlist[z][2:]    # strip out the '0x' on each hex string
			if len(nextword)==1:
				nextword='000'+nextword    # put the leading 0's back on if needed
			if len(nextword)==2:
				nextword='00'+nextword   
			if len(nextword)==3:
				nextword='0'+nextword
			idstring=idstring + ' ' + nextword      #  a bit wasteful of memory!
		cleaned_up_list=idstring 	
		return cleaned_up_list
	
	# end Clean_up_word_list
		
		
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagNAK
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagNAK(self,event):	
		'''Call the NAK function on the tag.'''


		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('NAK',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		returnlist=self.testTag.NAK(self.tagWorldTime)
		
		self.ReplyValueText.delete(1.0,END)			# clear widget
		self.ReplyValueText.insert(1.0,(returnlist[0]))		# update
		
		self.tagWorldTime=returnlist[1][1]
		self.updateDisplay()			

        #  end tagNAK

		
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagSelect
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			
	def tagSelect(self,event):	
		'''Get the parameters from the GUI and call the Select function on the tag.'''
		Target=self.panelSelSessionValue.get()
		Action=self.panelActionValue.get()
		Membank=self.panelSelMemBankValue.get()
		Pointer=self.PtrValue.get()
		Length=self.LenValue.get()
		Mask_text=self.MaskBits.get()    #  get the text in the entry box
		print 'mask text is:', Mask_text
		Mask=[]
		for i in range(0,len(Mask_text)):
			Mask=Mask+self.convertHexChartoBits(Mask_text[i])
		print 'in tagSelect, Mask is:', Mask
		print 'length of mask is:', len(Mask)
		Truncate=0	# not yet supported
		CRC16=0	# not yet implemented


		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Select',self.Tari,self.RTcal,self.TRcal,len(Mask))
		self.CommandTime[1]=self.tagWorldTime

		returnlist=self.testTag.Select(Target,Action,Membank,Pointer,Length,Mask,Truncate,CRC16,self.CommandTime)

		self.updateDisplay()

	#  end tagSelect
		
	
	def convertHexChartoBits(self,hexChar):
		'''This function converts a hex character (a nibble) to a list of four bits. '''
		hexCharlow=hexChar.lower()	#  convert to lower case if needed
		if hexCharlow=='0':
			bitList=[0,0,0,0]
		elif hexCharlow=='1':
			bitList=[0,0,0,1]
		elif hexCharlow=='2':
			bitList=[0,0,1,0]
		elif hexCharlow=='3':
			bitList=[0,0,1,1]
		elif hexCharlow=='4':
			bitList=[0,1,0,0]
		elif hexCharlow=='5':
			bitList=[0,1,0,1]
		elif hexCharlow=='6':
			bitList=[0,1,1,0]
		elif hexCharlow=='7':
			bitList=[0,1,1,1]
		elif hexCharlow=='8':
			bitList=[1,0,0,0]
		elif hexCharlow=='9':
			bitList=[1,0,0,1]
		elif hexCharlow=='a':
			bitList=[1,0,1,0]
		elif hexCharlow=='b':
			bitList=[1,0,1,1]
		elif hexCharlow=='c':
			bitList=[1,1,0,0]
		elif hexCharlow=='d':
			bitList=[1,1,0,1]
		elif hexCharlow=='e':
			bitList=[1,1,1,0]
		elif hexCharlow=='f':
			bitList=[1,1,1,1]			
			
		return bitList


		
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagRead
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	


			
	def tagRead(self,event):
		'''read a given set of words from tag memory'''	

		#  get the memory bank, word pointer, and word count from the relevant button /sliders
		Membank=self.panelReadMemBankValue.get()
		WordPtr=self.WordPtrValue.get()
		WordCount=self.WordLenValue.get()	
		
		#  need to add in CRC calculation!
		RN16=int(self.HandleEntry.get(),16)
		CRC16=0x00	#  for now!!!

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Read',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		
		returnlist=self.testTag.Read(Membank,WordPtr,WordCount,RN16,CRC16,self.CommandTime)
		
		self.ReplyValueText.delete(1.0,END)	# clear reply window
		if returnlist[0]=='NULL':
			self.ReplyValueText.insert(1.0,(returnlist[0]))		# update
		elif returnlist[0]==1:		# error code
			if returnlist[1]==3:
				errorstring='error:  memory overrun'
			elif returnlist[1]==4:
				errorstring='error: memory locked'
			else:
				errorstring='unknown error'
				
			self.ReplyValueText.insert(1.0,errorstring)		
		else:
			displaylist=returnlist[1]	                # list of numerical values
			numberlist=self.Numbers_to_hex(displaylist)	#  convert to list of hex strings
			wordlist=self.Clean_up_word_list(numberlist)
			self.ReplyValueText.insert(1.0,wordlist)
			self.tagWorldTime=returnlist[-1][1]
			#  debug!!!!!
			#  print 'in tagRead, the reply was:',returnlist
			self.updateDisplay()

	#  end tagRead

		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagWrite
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	


			
	def tagWrite(self,event):
		'''Write a word to memory.  Note that the Membank and WordPtr controls are reused from Read.
		Note also that cover encryption is not yet supported.   '''
		
		#   
		Membank=self.panelReadMemBankValue.get()
		WordPtr=self.WordPtrValue.get()
		WordToWrite=int(self.WriteWord.get(),16)
		#
		#  get the current handle
		RN16=int(self.HandleEntry.get(),16)
		#
		#	Need to implement CRC!!!

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Write',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime

		returnlist=self.testTag.Write(Membank,WordPtr,WordToWrite,RN16,'0000000000000000',self.CommandTime)
		
		#  clear reply window
		self.ReplyValueText.delete(1.0,END)
		self.ReplyValueText.insert(1.0,returnlist[0:2])	
		self.tagWorldTime=returnlist[-1][1]
		self.updateDisplay()

	#  end tagWrite
		
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	tagLock
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

		
	def tagLock(self,event):
		'''Write the various Lock bits if allowed by Permalock status.  Payload is assembled from the checkbuttons as a list
		of integer values of 1 or 0.'''
		
		Payload=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		Payload[0]=self.killLockEnableValue.get()
		Payload[1]=self.killpermaLockEnableValue.get()
		Payload[2]=self.accessLockEnableValue.get()
		Payload[3]=self.accesspermaLockEnableValue.get()
		Payload[4]=self.EPCLockEnableValue.get()
		Payload[5]=self.EPCpermaLockEnableValue.get()
		Payload[6]=self.TIDLockEnableValue.get()
		Payload[7]=self.TIDpermaLockEnableValue.get()
		Payload[8]=self.userLockEnableValue.get()
		Payload[9]=self.userpermaLockEnableValue.get()
		Payload[10]=self.killLockValue.get()
		Payload[11]=self.killpermaLockValue.get()
		Payload[12]=self.accessLockValue.get()
		Payload[13]=self.accesspermaLockValue.get()
		Payload[14]=self.EPCLockValue.get()
		Payload[15]=self.EPCpermaLockValue.get()
		Payload[16]=self.TIDLockValue.get()
		Payload[17]=self.TIDpermaLockValue.get()
		Payload[18]=self.userLockValue.get()
		Payload[19]=self.userpermaLockValue.get()

		self.tagWorldTime=self.tagWorldTime+2*self.RTcal     #  minimum delay for a command, T4
		self.CommandTime[0]=self.tagWorldTime
		self.tagWorldTime=self.tagWorldTime+self.commandDuration('Lock',self.Tari,self.RTcal,self.TRcal,0)
		self.CommandTime[1]=self.tagWorldTime
		
		returnlist=self.testTag.Lock(Payload, self.currHandle,0x0000,self.CommandTime)
		
		#  clear reply window
		self.ReplyValueText.delete(1.0,END)
		self.ReplyValueText.insert(1.0,returnlist[0:2])	
		self.tagWorldTime=returnlist[-1][1]
		self.updateDisplay()			
		
	# end tagLock

#   instantiate a root window and start the control main loop
root=Tk()
aPanel=G2_LogicalTag_controlPanel(root)
root.mainloop()

#  G2_LogicalTag_controlpanel   2.00.080415.1450
#  Daniel M. Dobkin   April 14, 2008
#  Enigmatics
#  www.enigmatic-consulting.com
		

		
